<template>
  <div :key="language_switch">
    <q-card flat v-if="show_render">
      <q-card-section class="text-primary hypercube_heading text-weight-bold">
        Dimension table: <span v-if="hypercube" v-html="show_label(hypercube)" role="heading"></span>
      </q-card-section>
      <div>
        <Hypercube :nt_version=nt_version :dts_name="dts_name" :linkrole_rowid="hypercube.linkrole_rowid"
        v-on:nodeClicked="show_concept" v-on:concept_clicked="show_node"></Hypercube>
      </div>
    </q-card>
    <q-card flat>
      <q-card-section class="text-primary hypercube_heading text-weight-bold">
        Primaire Items: <span v-if="hypercube" v-html="show_label(hypercube)" role="heading"></span>
      </q-card-section>
      <div class="items q-pb-sm" v-if="hypercube">
        <table class="definitionlink_table" title="Primaire posten">
          <thead>
          <tr>
            <th title="In de presentatie kunnen andere labels worden gebruikt">Standaard Label</th>
            <th title="Het concept van deze post">Concept</th>
            <th title="Volgnummer">#</th>
          </tr>
          </thead>
          <tbody>
          <LineItems :lineitems="hypercube.line_items" depth="0" v-on:conceptClicked="show_concept"></LineItems>
          </tbody>
        </table>

<!--          <tr v-for="line in hypercube.line_items"-->
<!--              :key="line.concept_id"-->
<!--              :id="line.concept_id"-->
<!--              class="pointer"-->
<!--              tabindex="0"-->
<!--              title="Klik voor details"-->
<!--              :class="{active: current_line_item===line.concept.id}">-->
<!--            <td class="detail_bg">-->
<!--                <span style="white-space: nowrap;">-->
<!--                  <q-icon v-if="current_line_item===line.concept.id" name="arrow_right" size="30"></q-icon>-->
<!--                  {{ line.order }}-->
<!--                </span>-->
<!--            </td>-->
<!--            <td class="detail_bg" v-html="show_label(line.concept)"></td>-->
<!--            <td class="detail_bg">{{ line.concept.name }}</td>-->
<!--          </tr>-->
      </div>
    </q-card>
    <q-card flat v-if="hypercube.dimensions && hypercube.dimensions.length" role="region"
            aria-label="Gekoppelde dimensies">
      <q-card-section class="text-green-10 dimension__heading text-weight-bold">
        <div role="heading">Dimensions</div>
      </q-card-section>
      <DimensionCard v-for="dimension in hypercube.dimensions"
                     :dimension="dimension"
                     :key="dimension.concept_id"
                     v-on:dim_conceptClicked="dim_show_concept">
      </DimensionCard>
    </q-card>
  </div>
</template>

<script>
import SharedMethods from "components/SharedMethods";
import DimensionCard from "components/DimensionCard";
import LineItems from "components/LineItems";
import Hypercube from "components/Hypercube";

export default {
  name: "DefinitionLinkDetailCard",
  components: {Hypercube, LineItems, DimensionCard},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  props: {
    hypercube: undefined,
    nt_version: String,
    dts_name: String,
  },
  computed: {
    lines() {
      return this.hypercube.line_items
    },
    show_render: function () {
      if (this.$route.path.includes("/definition")) {
        return true
      }
      return false
    },
  },
  data() {
    return {
      line_columns: [
        {name: 'order', label: '#', field: 'order'},
        {name: 'concept', label: 'Concept', field: 'concept_id'}
      ],
      concept_detail_id: undefined,
      language_switch: 0,
      current_line_item: undefined,
    }
  },
  watch: {
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  },
  methods: {
    show_node: function(node) {
      this.$emit('nodeClicked', node)
    },
    show_concept: function (concept_id) {
      this.$emit('conceptClicked', concept_id)
    },
    dim_show_concept: function (concept) {
      this.$emit('dim_conceptClicked', concept)
    }
  },
  emits: ["conceptClicked", "dim_conceptClicked", "nodeClicked"]
}
</script>

<style scoped lang="scss">
.hypercube_heading {
  border-bottom: 1px solid $blue;
  font-size: 20px;
}

.dimension__heading {
  border-left: 10px solid $green-10;
  border-bottom: 1px solid $green-10;
  font-size: 20px;
  margin-bottom: 10px;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

table {
  width: 95%;
  border-collapse: collapse;
  margin: 10px auto;
  border: 1px solid $blue;
}

th {
  text-align: left;
}

td, th {
  border: 1px solid $blue-grey;
  padding: 4px 5px;
}

tr.pointer:hover {
  background-color: $list_selected_bg;
  opacity: 0.8;
  color: white;
}

tr.pointer:hover td {
  background: transparent;
}

.pointer {
  cursor: pointer;
}

tr.pointer .active,
.active > .detail_bg {
  background-color: transparent;
}

</style>
